uses Os2base, Crt;

{  0  - all ok
  -1 - misc tcp error
  -2 - hostname resolving error
  -3 - connection refused
  -4 - tcp send error
  -5 - answer timeout error
  -6 - tcp read error
   1 - port open error
   2 - port set parameters error
   3 - port set signals error }
function  Comd_open(const host:PChar;
		    port_N:Longint;
		    speed:Longint;
		    dlen:Longint;
		    parity:Longint;
		    stop:Longint;
		    signals:Longint;
		    break_ms:Longint):Longint; Cdecl;
	  external 'comd_cli' index 200;

function  Comd_close:Longint; Cdecl;
	  external 'comd_cli' index 203;

function  Comd_read(var buf; buflen:Longint):Longint; Cdecl;
	  external 'comd_cli' index 201;

function  Comd_Write(var buf; buflen:Longint):Longint; Cdecl;
	  external 'comd_cli' index 202;


var
   l				       :  Longint;
   c				       :  Char;

function  Reader(p:Pointer):Longint;
var
   buf				       :  String;
   l				       :  Longint;
begin
   while true do
   begin
      l:=Comd_read(buf[1],sizeof(buf)-1);
      if l <=0 then Halt;
      buf[0]:=Chr(l);
      Write(buf);
   end;
end;

begin
   l:=Comd_open('localhost',2,19200,8,0,0,3,0);
   if l <> 0 then
   begin
      WriteLn(l);
      Halt;
   end;

   WriteLn('connected to ComD.');

   System.BeginThread(nil,32000,Reader,nil,
		      Create_Ready+Stack_Committed,l);

   while true do
   begin
      c:=ReadKey;
      l:=Comd_write(c,1);
      if l <= 0 then Halt;
   end;
end.



